/*     chatServer.java
 *      Ahmet E. Topcu
 *
 *      This chatSever is the server program for Network chatting.
 *      It has three classes chatMasterThread, streamManager and 
 *      chatServerWorker. chatMasterThread invoked by main method 
 *      and make a server socket. If there is client, it make 
 *      stream manager and wait next client. StreamManager manage
 *      stream and broadcast it. chatServerWorker recieve message from
 *      client and deliever it to chaStreamManager. If there is request
 *      for disconnection from client, it call stream Remove in chat-
 *      StreamManager. 
 *  
 */
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.Vector ;
import java.util.Enumeration ;
public class chatServer {

// main method invoke chatMaster Thread
        public static void main(String[] args) {
                new chatMasterThread();
        }

}

// make a server socket and if client is binding, make chatServerWorker
// and waiting another client
class chatMasterThread {
       
        streamManager bfc;
        ServerSocket s;
        Socket  sock;
        Vector allusers;       
        public chatMasterThread(){
allusers=new Vector();
	    
                System.out.println("chat server master thread envoked");
                bfc = new streamManager();      

// Open server socket port
                try {
                        s = new ServerSocket( 9765);
                        System.out.println( "Socket successfully working" );
                }       
                catch ( IOException e ){
                System.out.println( "  Socket  connection error " );
                        return;
                }       

// accept() waiting the client and arrange the socket
                while( true ){
                        try {
                                sock = s.accept();
                                System.out.println("New connection established");
                                chatServerWorker th = new chatServerWorker(bfc,sock,this);
				
                        }
                        catch (IOException e){
                        }               
                }
        }
}

// streamManager maintain the stream array  
class streamManager {
        private DataOutputStream streamLst[];
        private int cNumber[];
        private int cursor;
        private int cGenerator; 

        public streamManager() {
                streamLst = new DataOutputStream [30];
                cNumber = new int[30];
                cursor = 0;
                cGenerator = 0;
        }

        public synchronized void messageSend(String msg, int cnum){
                if(cursor == 0) return;
                try {
                   for(int i = 0; i < cursor; i++ ){
                        if(cNumber[i] != cnum)
                                streamLst[i].writeUTF(msg);             
                   }
                }
                catch ( IOException e ) {
                   System.out.println( "error message : Cannot write to the network" );
                }
        }
        public synchronized int addStream(DataOutputStream ds){
                streamLst[cursor] = ds;
                cNumber[cursor++] = cGenerator;
                return(cGenerator++);   
        }
// removeStream remove the stream from array by disconnection
        public synchronized void removeStream(int strnum){
                int     stop = -1;
                System.out.println("Remove Stream " + strnum);

                for(int i=0;i< cursor; i++) { 
                        System.out.print(cNumber[i]); 
                        System.out.print(" "); 
                }
                        
                System.out.println("");

                if(cursor == 0) return;
                else if(cursor == 1) {
                          cursor = 0;
                          return;
                }

                for(int i = 0 ; i < cursor -1 && stop == -1 ; i++ )
                        if( cNumber[i] == strnum ) {
                                stop = i;       
                        }

                if(stop != -1)
                  for(int i = stop ; i < cursor -1 ; i++ ){
                        System.out.println("Remove Stream -- " + i);
                        streamLst[i] = streamLst[i+1];
                        cNumber[i] = cNumber[i+1];
                  }
                cursor--;

                for(int i=0;i< cursor; i++) {
                  System.out.print(cNumber[i]) ; 
                  System.out.print(" "); 
                }
                System.out.println("");
        }
}

// chatServerWorker get stream from client 
// and deliever it to stream manager
class chatServerWorker extends Thread {
        streamManager  bctor;
        int  streamNum;
        DataInputStream inStr;
        DataOutputStream outStr;
        chatMasterThread server;
        public chatServerWorker(streamManager bc,Socket s,chatMasterThread  _server){
	        server=_server;
                bctor = bc;
		
                try {
                        System.out.println("New curior thread envoked");
                        inStr = new DataInputStream(s.getInputStream());
                        outStr = new DataOutputStream(s.getOutputStream());
                }
                catch (IOException e){
                        System.out.println("Stream conversion error");
                        try {
                                s.close();
                        }
                        catch (IOException se) {
                                System.out.println("Socket Close error");
                        }
                }
                streamNum = bctor.addStream(outStr);
                this.start();
        }

// if client send "BYE", then socket is disconnected
        public void run() {
                String rcbmsg;
		boolean inlist=false;
                System.out.println("Thread running");
                while(true){
                  try {
                        rcbmsg = inStr.readUTF();
                        if( rcbmsg.equals("BYE") ){
                          bctor.removeStream(streamNum);
			  
                          return;
                        }
			if (!inlist) {
			    String name= rcbmsg.substring(0,rcbmsg.indexOf('>'));
			    System.out.println("User name is "+name);
			    server.allusers.addElement(name);
			    String allusers="";
			    
         for (Enumeration e = server.allusers.elements() ; e.hasMoreElements() ;) {
             //System.out.println(e.nextElement());
	     allusers+=e.nextElement()+"+";
	     
         }
	 
			    bctor.messageSend("USERS+"+allusers,-347632);
			   inlist=true;
			} 
			else  bctor.messageSend(rcbmsg,streamNum);
                        System.out.println("Receive" + streamNum + ":" + rcbmsg);
                        
                  }
                  catch (IOException e){
                  }     
                }
        }
}

